<html>
<head>
  <title>The scrollutil::scrollarea Command</title>

  <meta name="Author" content="Csaba Nemethi">
  <meta name="Keywords" content="scrollarea, widget, scrollbar">

  <link rel="stylesheet" type="text/css" href="stylesheet.css">
</head>

<body bgcolor="#FFFFFF">
  <div align="center">
    <h1>The <code><b>scrollutil::scrollarea</b></code> Command</h1>

    <h2>For Scrollutil Version 1.1</h2>

    <h3>by</h3>

    <h2>Csaba Nemethi</h2>

    <address>
      <a href="mailto:csaba.nemethi@t-online.de">csaba.nemethi@t-online.de</a>
    </address>
  </div>
  <hr>

  <h2 id="contents">Contents</h2>

  <ul>
    <li><a href="#quick_ref">Quick Reference</a></li>

    <li><a href="#detailed_ref">Detailed Reference</a></li>
  </ul>

  <div align="center">
    <p><a href="index.html">Start page</a></p>
  </div>
  <hr>

  <h2 id="quick_ref">Quick Reference</h2>

  <dl>
    <dt><a href="#name">NAME</a></dt>

    <dd><code>scrollutil::scrollarea</code> &ndash; Create and manipulate
    scrollarea widgets</dd>

    <dt class="tm"><a href="#synopsis">SYNOPSIS</a></dt>

    <dd>
      <pre>
<b>scrollutil::scrollarea</b> <i>pathName</i> ?<i>options</i>?
</pre>
    </dd>

    <dt><a href="#std_options">STANDARD OPTIONS</a></dt>

    <dd>
      <pre>
<b>-background   -highlightbackground  -relief
-borderwidth  -highlightcolor
-cursor       -highlightthickness</b>
</pre>
    </dd>

    <dt><a href="#widget_options">WIDGET-SPECIFIC OPTIONS</a></dt>

    <dd><code><b><a href="#lockinterval">-lockinterval</a></b>
    <i>milliseconds</i></code></dd>

    <dd><code><b><a href="#respectheader">-respectheader</a></b>
    <i>boolean</i></code></dd>

    <dd><code><b><a href="#respecttitlecolumns">-respecttitlecolumns</a></b>
    <i>boolean</i></code></dd>

    <dd><code><b><a href="#takefocus">-takefocus</a></b>
    <b>0</b>|<b>1</b>|<b>""</b>|<i>command</i></code></dd>

    <dd><code><b><a href="#xscrollbarmode">-xscrollbarmode</a></b>
    <b>static</b>|<b>dynamic</b>|<b>none</b></code></dd>

    <dd><code><b><a href="#yscrollbarmode">-yscrollbarmode</a></b>
    <b>static</b>|<b>dynamic</b>|<b>none</b></code></dd>

    <dt class="tm"><a href="#description">DESCRIPTION</a></dt>

    <dt class="tm"><a href="#widget_command">WIDGET COMMAND</a></dt>

    <dd><code><i>pathName</i> <b><a href="#cget">cget</a></b>
    <i>option</i></code></dd>

    <dd><code><i>pathName</i> <b><a href="#configure">configure</a></b>
    ?<i>option</i>? ?<i>value</i> <i>option</i> <i>value</i> ...?</code></dd>

    <dd><code><i>pathName</i> <b><a href="#setwidget">setwidget</a></b>
    <i>widget</i></code></dd>

    <dd><code><i>pathName</i> <b><a href="#widget">widget</a></b></code></dd>

    <dt class="tm"><a href="#bindings">BINDINGS</a></dt>

    <dt class="tm"><a href="#keywords">KEYWORDS</a></dt>

    <dd>scrollarea, widget, scrollbar</dd>
  </dl>

  <div align="center">
    <p><a href="#contents">Contents</a>&nbsp;&nbsp;&nbsp;&nbsp; <a href=
    "index.html">Start page</a></p>
  </div>
  <hr>

  <h2 id="detailed_ref">Detailed Reference</h2>

  <dl>
    <dt id="name"><b>NAME</b></dt>

    <dd><code>scrollutil::scrollarea</code> &ndash; Create and manipulate
    scrollarea widgets</dd>

    <dt class="tm" id="synopsis"><b>SYNOPSIS</b></dt>

    <dd>
      <pre>
<b>scrollutil::scrollarea</b> <i>pathName</i> ?<i>options</i>?
</pre>
    </dd>

    <dt id="std_options"><b>STANDARD OPTIONS</b></dt>

    <dd>
      <pre>
<b>-background   -highlightbackground  -relief
-borderwidth  -highlightcolor
-cursor       -highlightthickness</b>
</pre>
    </dd>

    <dd>See the <b>options</b> manual entry for details on the standard Tk
    widget options.&nbsp; The <code><b>-background</b></code>,
    <code><b>-highlightbackground</b></code>,
    <code><b>-highlightcolor</b></code>, and
    <code><b>-highlightthickness</b></code> options are only supported by the
    Scrollutil package, but not by Scrollutil_tile.&nbsp; They have the same
    default values as the options of the same names for Tk frame
    widgets.&nbsp; The default values of the remaining standard options
    are:</dd>

    <dd>
      <pre>
<b>-borderwidth</b> 1 <b>-cursor</b> "" <b>-relief sunken</b>
</pre>
    </dd>

    <dd><b>REMARK:</b>&nbsp; When configuring the
    <code><b>-borderwidth</b></code> or <code><b>-relief</b></code> option, if
    as a result of this action the scrollarea has a positive
    <code><b>-borderwidth</b></code> value (e.g., the default <code>1</code>)
    and a <code><b>-relief</b></code> value other than <code><b>flat</b></code>
    (e.g., the default <code><b>sunken</b></code>), then the
    <code><b>-borderwidth</b></code> option of the widget embedded into the
    scrollarea via the <code><b><a href="#setwidget">setwidget</a></b></code>
    subcommand of the associated Tcl command will automatically be set to
    <code>0</code>, provided that the embedded widget supports this
    option.</dd>

    <dt class="tm" id="widget_options"><b>WIDGET-SPECIFIC OPTIONS</b></dt>

    <dd class="tm" id="lockinterval">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-lockinterval</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;lockInterval</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;LockInterval</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>Specifies the time interval in milliseconds for which the scrollbars
        having the display mode <code><b>dynamic</b></code> (see the
        <code><b><a href="#xscrollbarmode">-xscrollbarmode</a></b></code> and
        <code><b><a href="#yscrollbarmode">-yscrollbarmode</a></b></code>
        options) will be protected from being unmapped after being mapped, in
        order to avoid any shimmering effects.&nbsp; Without this locking
        mechanism, under some rare circumstances a dynamic scrollbar could get
        mapped and unmapped in an endless loop, thus giving rise to an annoying
        and often dangerous flickering effect.&nbsp; The same problem can arise
        due to a too small <code><b>-lockinterval</b></code> value.&nbsp; The
        default is <code>1</code>, which works as expected in the vast majority
        of cases.&nbsp; Should you experience any shimmering in one of your
        scrollarea widgets, just set this option for that scrollarea to a
        sufficiently large value (e.g., <code>100</code>).</p>
      </blockquote>
    </dd>

    <dd class="tm" id="respectheader">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-respectheader</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;respectHeader</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;RespectHeader</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>This option is only relevant if the widget embedded into the
        scrollarea with the aid of the <code><b><a href=
        "#setwidget">setwidget</a></b></code> subcommand of the associated Tcl
        command is a <a href="http://www.nemethi.de/tablelist/">tablelist</a>
        and the Tablelist version being used is 6.5 or later.&nbsp; Its value
        must be a boolean specifying whether the vertical scrollbar should
        appear below the tablelist widget's header, thus respecting the native
        look & feel on Mac OS X Aqua and on many modern Linux systems.&nbsp;
        The default is <code>1</code> on the windowing systems
        <code><b>aqua</b></code> and <code><b>x11</b></code>, and
        <code>0</code> on <code><b>win32</b></code>.</p>
      </blockquote>
    </dd>

    <dd id="respecttitlecolumns">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-respecttitlecolumns</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;respectTitleColumns</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;RespectTitleColumns</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>This option is only relevant if the widget embedded into the
        scrollarea with the aid of the <code><b><a href=
        "#setwidget">setwidget</a></b></code> subcommand of the associated Tcl
        command is a <a href="http://www.nemethi.de/tablelist/">tablelist</a>
        and the Tablelist version being used is 6.5 or later.&nbsp; Its value
        must be a boolean specifying whether the horizontal scrollbar should
        start to the right of the tablelist widget's non-scrollable title
        column area if the value of the <code><b><a href=
        "http://www.nemethi.de/tablelist/tablelistWidget.html#titlecolumns">-titlecolumns</a></b></code>
        tablelist option is positive.&nbsp; The default is <code>1</code>.</p>
      </blockquote>
    </dd>

    <dd id="takefocus">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-takefocus</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;takeFocus</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;TakeFocus</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>This option determines whether the scrollarea accepts the focus
        during keyboard traversal.&nbsp; It is almost identical to the standard
        option of the same name (see the <b>options</b> manual entry for
        details).&nbsp; The only difference is that not the scrollarea itself
        but the widget embedded into it via the <code><b><a href=
        "#setwidget">setwidget</a></b></code> subcommand of the associated Tcl
        command will receive the focus during keyboard traversal with the
        standard keys (<code>Tab</code> and <code>Shift-Tab</code>).&nbsp; The
        default is <code>0</code>, being that a scrollarea is esentially a
        frame containing the above-mentioned widget and two scrollbars.</p>
      </blockquote>
    </dd>

    <dd id="xscrollbarmode">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-xscrollbarmode</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;xScrollbarMode</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;ScrollbarMode</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>Specifies the display mode to be used for the horizontal
        scrollbar.&nbsp; The allowed values are <code><b>static</b></code>,
        <code><b>dynamic</b></code>, and <code><b>none</b></code>.&nbsp; In
        <code><b>static</b></code> mode the scrollbar is displayed at all
        times.&nbsp; In <code><b>dynamic</b></code> mode (which is the default)
        the scrollbar is mapped and unmapped as needed.&nbsp; The display mode
        <code><b>none</b></code> disables the scrollbar display.</p>
      </blockquote>
    </dd>

    <dd id="yscrollbarmode">
      <table border="0" cellpadding="0" cellspacing="0">
        <tr>
          <td>Command-Line Name:&nbsp;</td>

          <td><code><b>-yscrollbarmode</b></code></td>
        </tr>

        <tr>
          <td>Database Name:</td>

          <td><code><b>&nbsp;yScrollbarMode</b></code></td>
        </tr>

        <tr>
          <td>Database Class:</td>

          <td><code><b>&nbsp;ScrollbarMode</b></code></td>
        </tr>
      </table>

      <blockquote>
        <p>Specifies the display mode to be used for the vertical
        scrollbar.&nbsp; The allowed values are <code><b>static</b></code>,
        <code><b>dynamic</b></code>, and <code><b>none</b></code>.&nbsp; In
        <code><b>static</b></code> mode the scrollbar is displayed at all
        times.&nbsp; In <code><b>dynamic</b></code> mode (which is the default)
        the scrollbar is mapped and unmapped as needed.&nbsp; The display mode
        <code><b>none</b></code> disables the scrollbar display.</p>
      </blockquote>
    </dd>

    <dt id="description"><b>DESCRIPTION</b></dt>

    <dd>The <code><b>scrollutil::scrollarea</b></code> command creates a new
    window named <code><i>pathName</i></code> and of the class
    <code><b>Scrollarea</b></code>, and makes it into a <b>scrollarea</b>
    widget.&nbsp; Additional options, described above, may be specified on the
    command line or in the option database to configure aspects of the
    scrollarea such as its borderwidth, relief, and display mode to be used for
    the scrollbars.&nbsp; The <code><b>scrollutil::scrollarea</b></code>
    command returns its <code><i>pathName</i></code> argument.&nbsp; At the
    time this command is invoked, there must not exist a window named
    <code><i>pathName</i></code>, but <code><i>pathName</i></code>'s parent
    must exist.</dd>

    <dd class="tm">A scrollarea is a mega-widget consisting of a scrollable
    widget specified with the aid of the <code><b><a href=
    "#setwidget">setwidget</a></b></code> subcommand of the associated Tcl
    command as well as two scrollbars connected with that widget.&nbsp; These
    components are managed within the scrollarea using
    <code><b>grid</b></code>.&nbsp; The scrollbars, named
    <code><b>hsb</b></code> (with&nbsp; <code><b>-orient
    horizontal</b></code>)&nbsp; and <code><b>vsb</b></code> (with&nbsp;
    <code><b>-orient vertical</b></code>)&nbsp; are direct children of the
    scrollarea.&nbsp; The display mode of each scrollbar can be
    <code><b>static</b></code>, <code><b>dynamic</b></code>, or
    <code><b>none</b></code> (see the <code><b><a href=
    "#xscrollbarmode">-xscrollbarmode</a></b></code> and <code><b><a href=
    "#yscrollbarmode">-yscrollbarmode</a></b></code> configuration
    options).&nbsp; The <code><b>-takefocus</b></code> option of both
    scrollbars is set to <code>0</code>.&nbsp; In the Scrollutil_tile package
    the scrollbars are created as tk::scrollbar widgets, except on Mac OS X,
    where the native ttk::scrollbar widget of the <code><b>aqua</b></code>
    theme doesn't look as expected.</dd>

    <dd class="tm">If the widget embedded into the scrollarea via
    <code><b>setwidget</b></code> is a <a href=
    "http://www.nemethi.de/tablelist/">tablelist</a> and Tablelist version 6.5
    or later is being used then the scrollarea can also contain siblings of the
    tablelist widget above the vertical scrollbar and/or to the left of the
    horizontal one, causing the vertical scrollbar to be displayed below the
    tablelist's header and/or the horizontal scrollbar to appear to the right
    of the tablelist's title column area, depending on the values of the
    <code><b><a href=
    "#respectheader">-respectheader</a></b></code> and <code><b><a href=
    "#respecttitlecolumns">-respecttitlecolumns</a></b></code> configuration
    options.</dd>

    <dt class="tm" id="widget_command"><b>WIDGET COMMAND</b></dt>

    <dd>
      The <code><b>scrollutil::scrollarea</b></code> command creates a new Tcl
      command whose name is <code><i>pathName</i></code>.&nbsp; This command
      may be used to invoke various operations on the widget.&nbsp; It has the
      following general form:

      <blockquote>
        <pre>
<i>pathName</i> <i>option</i> ?<i>arg</i> <i>arg</i> ...?
</pre>
      </blockquote>
    </dd>

    <dd><code><i>option</i></code> and the <code><i>arg</i></code>s determine
    the exact behavior of the command.&nbsp; The following commands are
    possible for scrollarea widgets:</dd>

    <dd>
      <dl>
        <dt class="tm" id="cget"><code><i>pathName</i> <b>cget</b>
        <i>option</i></code></dt>

        <dd>Returns the current value of the configuration option given by
        <code><i>option</i></code>, which may have any of the values accepted
        by the <code><b>scrollutil::scrollarea</b></code> command.</dd>

        <dt class="tm" id="configure"><code><i>pathName</i> <b>configure</b>
        ?<i>option</i>? ?<i>value</i> <i>option</i> <i>value</i>
        ...?</code></dt>

        <dd>Queries or modifies the configuration options of the widget.&nbsp;
        If no <code><i>option</i></code> is specified, the command returns a
        list describing all of the available options for
        <code><i>pathName</i></code> (see <code><b>Tk_ConfigureInfo</b></code>
        for information on the format of this list).&nbsp; If
        <code><i>option</i></code> is specified with no
        <code><i>value</i></code>, then the command returns a list describing
        the one named option (this list will be identical to the corresponding
        sublist of the value returned if no <code><i>option</i></code> is
        specified).&nbsp; If one or more
        <code><i>option</i></code>-<code><i>value</i></code> pairs are
        specified, then the command modifies the given widget option(s) to have
        the given value(s); in this case the return value is an empty
        string.&nbsp; <code><i>option</i></code> may have any of the values
        accepted by the <code><b>scrollutil::scrollarea</b></code>
        command.</dd>

        <dt class="tm" id="setwidget"><code><i>pathName</i> <b>setwidget</b>
        <i>widget</i></code></dt>

        <dd>The <code><i>widget</i></code> argument must be the path name of an
        existing widget or an empty string.&nbsp; In the first case, the
        command manages the widget to fill the top-left part of the scrollarea
        and connects it with the scrollbars by setting its
        <code><b>-xscrollcommand</b></code> and
        <code><b>-yscrollcommand</b></code> options to appropriate wrappers for
        the <code><b>set</b></code> command of the two scrollbars and setting
        the <code><b>-command</b></code> option of the scrollbars to&nbsp;
        <code>[<b>list</b> <i>widget</i> <b>xview</b>]</code>&nbsp; and&nbsp;
        <code>[<b>list</b> <i>widget</i> <b>yview</b>]</code>,&nbsp;
        respectively.&nbsp; If <code><i>widget</i></code> is an empty string
        then the widget passed to the most recent <code><b>setwidget</b></code>
        invocation (if any) is unmanaged and unconnected from the
        scrollbars.&nbsp; The return value is the argument passed to the
        previous successful invocation of this subcommand, or an empty string
        if there was no successful <code><b>setwidget</b></code> invocation
        before.</dd>

        <dd class="tm"><b>REMARK 1:</b>&nbsp; If <code><i>widget</i></code> is
        nonempty and the value of the <code><b><a href=
        "#xscrollbarmode">-xscrollbarmode</a></b></code> option is different
        from <code><b>none</b></code> then <code><i>widget</i></code> must be a
        horizontally scrollable widget, meaning that it must support the
        <code><b>-xscrollcommand</b></code> configuration option and the
        associated Tcl command must have the <code><b>xview</b></code>
        subcommand.&nbsp; Similarly, if <code><i>widget</i></code> is nonempty
        and the value of the <code><b><a href=
        "#yscrollbarmode">-yscrollbarmode</a></b></code> option is different
        from <code><b>none</b></code> then <code><i>widget</i></code> must be a
        vertically scrollable widget, meaning that it must support the
        <code><b>-yscrollcommand</b></code> configuration option and the
        associated Tcl command must have the <code><b>yview</b></code>
        subcommand.&nbsp; Consequently, if <code><i>widget</i></code> is an
        entry or ttk::entry then this subcommand will only be successful if the
        <code><b>-yscrollbarmode</b></code> option was previously set to
        <code><b>none</b></code>.</dd>

        <dd class="tm"><b>REMARK 2:</b>&nbsp; The widget identified by the
        <code><i>widget</i></code> argument must be a child of the scrollarea
        or of one of the latter's ascendants.&nbsp; This minor restriction is
        imposed by the <code><b>grid</b></code> geometry manager.</dd>

        <dd class="tm"><b>REMARK 3:</b>&nbsp; When the widget whose path name
        was passed to <code><b>setwidget</b></code> gets destroyed, this
        subcommand is automatically invoked with an empty string as
        argument.</dd>

        <dd class="tm"><b>REMARK 4:</b>&nbsp; This subcommand sets the
        <code><b>-highlightthickness</b></code> option of
        <code><i>widget</i></code> to <code>0</code> if
        <code><i>widget</i></code> supports this configuration option.&nbsp; In
        addition, if the scrollarea has a positive
        <code><b>-borderwidth</b></code> value (e.g., the default
        <code>1</code>) and a <code><b>-relief</b></code> value other than
        <code><b>flat</b></code> (e.g., the default <code><b>sunken</b></code>)
        then this subcommand sets the <code><b>-borderwidth</b></code> option
        of <code><i>widget</i></code> to <code>0</code>, provided that
        <code><i>widget</i></code> supports this option.</dd>

        <dt class="tm" id="widget"><code><i>pathName</i>
        <b>widget</b></code></dt>

        <dd>Returns the argument passed to the most recent successful
        invocation of the <code><b><a href=
        "#setwidget">setwidget</a></b></code> subcommand, or an empty string if
        there was no successful invocation of that subcommand yet.</dd>
      </dl>
    </dd>

    <dt class="tm" id="bindings"><b>BINDINGS</b></dt>

    <dd>When a new scrollarea is created, it has no default event bindings:
    scrollareas are not intended to be interactive.</dd>

    <dt class="tm" id="keywords"><b>KEYWORDS</b></dt>

    <dd>scrollarea, widget, scrollbar</dd>
  </dl>

  <div align="center">
    <p><a href="#contents">Contents</a>&nbsp;&nbsp;&nbsp;&nbsp; <a href=
    "index.html">Start page</a></p>
  </div>
</body>
</html>
